#DEFINE HORZRES 8
#DEFINE VERTRES	10
#DEFINE PHYSICALOFFSETX 112
#DEFINE PHYSICALOFFSETY 113

#define PFD_DRAW_TO_WINDOW  4
#define PFD_SUPPORT_OPENGL 0x00000020
#define PFD_DOUBLEBUFFER 1
#define PFD_TYPE_RGBA 0
#define PFD_MAIN_PLANE 0

#define DCB_RESET 	0x0001
#define DCB_ACCUMULATE  0x0002

* Pen Styles
#define PS_SOLID         0
#define PS_DASH          1      && ------- 
#define PS_DOT           2      && ....... 
#define PS_DASHDOT       3      && _._._._ 
#define PS_DASHDOTDOT    4      && _.._.._ 
#define PS_NULL   	 5
#define PS_INSIDEFRAME   6
#define PS_USERSTYLE   	 7
#define PS_ALTERNATE   	 8
#define PS_STYLE_MASK   15

* DrawText() Format Flags
#DEFINE DT_TOP 0
#DEFINE DT_LEFT 0
#DEFINE DT_CENTER 1
#DEFINE DT_RIGHT 2
#DEFINE DT_VCENTER 4
#DEFINE DT_BOTTOM 8
#DEFINE DT_WORDBREAK 0x10
#DEFINE DT_SINGLELINE 0x20
#DEFINE DT_EXPANDTABS 0x40
#DEFINE DT_TABSTOP 0x80
#DEFINE DT_NOCLIP 0x100
#DEFINE DT_EXTERNALLEADING 0x200
#DEFINE DT_CALCRECT 0x400
#DEFINE DT_NOPREFIX 0x800
#DEFINE DT_INTERNAL 0x1000
#DEFINE DT_HIDEPREFIX 0x00100000
#DEFINE DT_PREFIXONLY 0x00200000
#DEFINE DT_EDITCONTROL 0x2000
#DEFINE DT_PATH_ELLIPSIS 0x4000
#DEFINE DT_END_ELLIPSIS 0x8000
#DEFINE DT_MODIFYSTRING 0x10000
#DEFINE DT_RTLREADING 0x20000
#DEFINE DT_WORD_ELLIPSIS 0x40000

* Background Modes
#DEFINE TRANSPARENT 1
#DEFINE OPAQUE 2

* mode selections for the device mode function
#DEFINE DM_UPDATE 1
#DEFINE DM_COPY 2
#DEFINE DM_PROMPT 4
#DEFINE DM_MODIFY 8

#DEFINE DM_IN_BUFFER DM_MODIFY
#DEFINE DM_IN_PROMPT DM_PROMPT
#DEFINE DM_OUT_BUFFER DM_COPY
#DEFINE DM_OUT_DEFAULT DM_UPDATE

* ShowWindow() Commands
#DEFINE SW_HIDE 0
#DEFINE SW_SHOWNORMAL 1
#DEFINE SW_NORMAL 1
#DEFINE SW_SHOWMINIMIZED 2
#DEFINE SW_SHOWMAXIMIZED 3
#DEFINE SW_MAXIMIZE 3
#DEFINE SW_SHOWNOACTIVATE 4
#DEFINE SW_SHOW 5
#DEFINE SW_MINIMIZE 6
#DEFINE SW_SHOWMINNOACTIVE 7
#DEFINE SW_SHOWNA 8
#DEFINE SW_RESTORE 9
#DEFINE SW_SHOWDEFAULT 10
#DEFINE SW_MAX 10

* dwCreationFlag values
#DEFINE DEBUG_PROCESS                   0x00000001
#DEFINE DEBUG_ONLY_THIS_PROCESS         0x00000002
#DEFINE CREATE_SUSPENDED                0x00000004
#DEFINE DETACHED_PROCESS                0x00000008
#DEFINE CREATE_NEW_CONSOLE              0x00000010
#DEFINE NORMAL_PRIORITY_CLASS           0x00000020
#DEFINE IDLE_PRIORITY_CLASS             0x00000040
#DEFINE HIGH_PRIORITY_CLASS             0x00000080
#DEFINE REALTIME_PRIORITY_CLASS         0x00000100
#DEFINE CREATE_NEW_PROCESS_GROUP        0x00000200
#DEFINE CREATE_UNICODE_ENVIRONMENT      0x00000400
#DEFINE CREATE_SEPARATE_WOW_VDM         0x00000800
#DEFINE CREATE_SHARED_WOW_VDM           0x00001000
#DEFINE CREATE_FORCEDOS                 0x00002000
#DEFINE CREATE_DEFAULT_ERROR_MODE       0x04000000
#DEFINE CREATE_NO_WINDOW                0x08000000
#DEFINE PROFILE_USER                    0x10000000
#DEFINE PROFILE_KERNEL                  0x20000000
#DEFINE PROFILE_SERVER                  0x40000000

* Dual Mode API below this line. Dual Mode Structures also included.
#DEFINE STARTF_USESHOWWINDOW 1
#DEFINE STARTF_USESIZE 2
#DEFINE STARTF_USEPOSITION 4
#DEFINE STARTF_USECOUNTCHARS 8
#DEFINE STARTF_USEFILLATTRIBUTE 0x10
#DEFINE STARTF_RUNFULLSCREEN 0x20 && ignored for non-x86 platforms
#DEFINE STARTF_FORCEONFEEDBACK 0x40
#DEFINE STARTF_FORCEOFFFEEDBACK 0x80
#DEFINE STARTF_USESTDHANDLES 0x100
#DEFINE STARTF_USEHOTKEY 0x200

#DEFINE GENERIC_READ             0x80000000
#DEFINE GENERIC_WRITE            0x40000000
#DEFINE GENERIC_EXECUTE          0x20000000
#DEFINE GENERIC_ALL              0x10000000

#DEFINE INVALID_HANDLE_VALUE -1

#DEFINE FILE_SHARE_READ  	               0x00000001
#DEFINE FILE_SHARE_WRITE                   0x00000002
#DEFINE FILE_SHARE_DELETE                  0x00000004
#DEFINE FILE_ATTRIBUTE_READONLY            0x00000001
#DEFINE FILE_ATTRIBUTE_HIDDEN              0x00000002
#DEFINE FILE_ATTRIBUTE_SYSTEM              0x00000004
#DEFINE FILE_ATTRIBUTE_DIRECTORY           0x00000010
#DEFINE FILE_ATTRIBUTE_ARCHIVE             0x00000020
#DEFINE FILE_ATTRIBUTE_NORMAL              0x00000080
#DEFINE FILE_ATTRIBUTE_TEMPORARY           0x00000100
#DEFINE FILE_ATTRIBUTE_COMPRESSED          0x00000800
#DEFINE FILE_ATTRIBUTE_OFFLINE             0x00001000

#DEFINE CREATE_NEW 1
#DEFINE CREATE_ALWAYS 2
#DEFINE OPEN_EXISTING 3
#DEFINE OPEN_ALWAYS 4
#DEFINE TRUNCATE_EXISTING 5

#DEFINE VER_PLATFORM_WIN32s 0
#DEFINE VER_PLATFORM_WIN32_WINDOWS 1
#DEFINE VER_PLATFORM_WIN32_NT 2

* Define the NamedPipe definitions
* Define the dwOpenMode values for CreateNamedPipe
#DEFINE PIPE_ACCESS_INBOUND 1
#DEFINE PIPE_ACCESS_OUTBOUND 2
#DEFINE PIPE_ACCESS_DUPLEX 3

* File creation flags must start at the high end since they 
* are combined with the attributes

#DEFINE FILE_FLAG_WRITE_THROUGH 0x80000000
#DEFINE FILE_FLAG_OVERLAPPED 0x40000000
#DEFINE FILE_FLAG_NO_BUFFERING 0x20000000
#DEFINE FILE_FLAG_RANDOM_ACCESS 0x10000000
#DEFINE FILE_FLAG_SEQUENTIAL_SCAN 0x8000000
#DEFINE FILE_FLAG_DELETE_ON_CLOSE 0x4000000
#DEFINE FILE_FLAG_BACKUP_SEMANTICS 0x2000000
#DEFINE FILE_FLAG_POSIX_SEMANTICS 0x1000000

#DEFINE WRITE_DAC                0x00040000
#DEFINE WRITE_OWNER              0x00080000
#DEFINE ACCESS_SYSTEM_SECURITY   0x01000000

* Define the dwPipeMode values for CreateNamedPipe

#DEFINE PIPE_WAIT 0
#DEFINE PIPE_NOWAIT 1
#DEFINE PIPE_READMODE_BYTE 0
#DEFINE PIPE_READMODE_MESSAGE 2
#DEFINE PIPE_TYPE_BYTE 0
#DEFINE PIPE_TYPE_MESSAGE 4

* Define the well known values for CreateNamedPipe nMaxInstances

#DEFINE PIPE_UNLIMITED_INSTANCES 255

#DEFINE NMPWAIT_WAIT_FOREVER 0xFFFFFFFF
#DEFINE NMPWAIT_NOWAIT 1
#DEFINE NMPWAIT_USE_DEFAULT_WAIT 0

#DEFINE WAIT_FAILED 0xFFFFFFFF
#DEFINE WAIT_OBJECT_0 0

#DEFINE FORMAT_MESSAGE_ALLOCATE_BUFFER 0x100
#DEFINE FORMAT_MESSAGE_IGNORE_INSERTS 0x200
#DEFINE FORMAT_MESSAGE_FROM_STRING 0x400
#DEFINE FORMAT_MESSAGE_FROM_HMODULE 0x800
#DEFINE FORMAT_MESSAGE_FROM_SYSTEM 0x1000
#DEFINE FORMAT_MESSAGE_ARGUMENT_ARRAY 0x2000
#DEFINE FORMAT_MESSAGE_MAX_WIDTH_MASK 255

* Primary language IDs.

#DEFINE LANG_NEUTRAL                         0x00

#DEFINE LANG_AFRIKAANS                       0x36
#DEFINE LANG_ALBANIAN                        0x1c
#DEFINE LANG_ARABIC                          0x01
#DEFINE LANG_BASQUE                          0x2d
#DEFINE LANG_BELARUSIAN                      0x23
#DEFINE LANG_BULGARIAN                       0x02
#DEFINE LANG_CATALAN                         0x03
#DEFINE LANG_CHINESE                         0x04
#DEFINE LANG_CROATIAN                        0x1a
#DEFINE LANG_CZECH                           0x05
#DEFINE LANG_DANISH                          0x06
#DEFINE LANG_DUTCH                           0x13
#DEFINE LANG_ENGLISH                         0x09
#DEFINE LANG_ESTONIAN                        0x25
#DEFINE LANG_FAEROESE                        0x38
#DEFINE LANG_FARSI                           0x29
#DEFINE LANG_FINNISH                         0x0b
#DEFINE LANG_FRENCH                          0x0c
#DEFINE LANG_GERMAN                          0x07
#DEFINE LANG_GREEK                           0x08
#DEFINE LANG_HEBREW                          0x0d
#DEFINE LANG_HUNGARIAN                       0x0e
#DEFINE LANG_ICELANDIC                       0x0f
#DEFINE LANG_INDONESIAN                      0x21
#DEFINE LANG_ITALIAN                         0x10
#DEFINE LANG_JAPANESE                        0x11
#DEFINE LANG_KOREAN                          0x12
#DEFINE LANG_LATVIAN                         0x26
#DEFINE LANG_LITHUANIAN                      0x27
#DEFINE LANG_NORWEGIAN                       0x14
#DEFINE LANG_POLISH                          0x15
#DEFINE LANG_PORTUGUESE                      0x16
#DEFINE LANG_ROMANIAN                        0x18
#DEFINE LANG_RUSSIAN                         0x19
#DEFINE LANG_SERBIAN                         0x1a
#DEFINE LANG_SLOVAK                          0x1b
#DEFINE LANG_SLOVENIAN                       0x24
#DEFINE LANG_SPANISH                         0x0a
#DEFINE LANG_SWEDISH                         0x1d
#DEFINE LANG_THAI                            0x1e
#DEFINE LANG_TURKISH                         0x1f
#DEFINE LANG_UKRAINIAN                       0x22
#DEFINE LANG_VIETNAMESE                      0x2a

* Sublanguage IDs.

* The name immediately following SUBLANG_ dictates which primary
* language ID that sublanguage ID can be combined with to form a
* valid language ID.

#DEFINE SUBLANG_NEUTRAL                      0x00    && language neutral 
#DEFINE SUBLANG_DEFAULT                      0x01    && user default 
#DEFINE SUBLANG_SYS_DEFAULT                  0x02    && system default 

#DEFINE SUBLANG_ARABIC_SAUDI_ARABIA          0x01    && Arabic (Saudi Arabia) 
#DEFINE SUBLANG_ARABIC_IRAQ                  0x02    && Arabic (Iraq) 
#DEFINE SUBLANG_ARABIC_EGYPT                 0x03    && Arabic (Egypt) 
#DEFINE SUBLANG_ARABIC_LIBYA                 0x04    && Arabic (Libya) 
#DEFINE SUBLANG_ARABIC_ALGERIA               0x05    && Arabic (Algeria) 
#DEFINE SUBLANG_ARABIC_MOROCCO               0x06    && Arabic (Morocco) 
#DEFINE SUBLANG_ARABIC_TUNISIA               0x07    && Arabic (Tunisia) 
#DEFINE SUBLANG_ARABIC_OMAN                  0x08    && Arabic (Oman) 
#DEFINE SUBLANG_ARABIC_YEMEN                 0x09    && Arabic (Yemen) 
#DEFINE SUBLANG_ARABIC_SYRIA                 0x0a    && Arabic (Syria) 
#DEFINE SUBLANG_ARABIC_JORDAN                0x0b    && Arabic (Jordan) 
#DEFINE SUBLANG_ARABIC_LEBANON               0x0c    && Arabic (Lebanon) 
#DEFINE SUBLANG_ARABIC_KUWAIT                0x0d    && Arabic (Kuwait) 
#DEFINE SUBLANG_ARABIC_UAE                   0x0e    && Arabic (U.A.E) 
#DEFINE SUBLANG_ARABIC_BAHRAIN               0x0f    && Arabic (Bahrain) 
#DEFINE SUBLANG_ARABIC_QATAR                 0x10    && Arabic (Qatar) 
#DEFINE SUBLANG_CHINESE_TRADITIONAL          0x01    && Chinese (Taiwan) 
#DEFINE SUBLANG_CHINESE_SIMPLIFIED           0x02    && Chinese (PR China) 
#DEFINE SUBLANG_CHINESE_HONGKONG             0x03    && Chinese (Hong Kong) 
#DEFINE SUBLANG_CHINESE_SINGAPORE            0x04    && Chinese (Singapore) 
#DEFINE SUBLANG_DUTCH                        0x01    && Dutch 
#DEFINE SUBLANG_DUTCH_BELGIAN                0x02    && Dutch (Belgian) 
#DEFINE SUBLANG_ENGLISH_US                   0x01    && English (USA) 
#DEFINE SUBLANG_ENGLISH_UK                   0x02    && English (UK) 
#DEFINE SUBLANG_ENGLISH_AUS                  0x03    && English (Australian) 
#DEFINE SUBLANG_ENGLISH_CAN                  0x04    && English (Canadian) 
#DEFINE SUBLANG_ENGLISH_NZ                   0x05    && English (New Zealand) 
#DEFINE SUBLANG_ENGLISH_EIRE                 0x06    && English (Irish) 
#DEFINE SUBLANG_ENGLISH_SOUTH_AFRICA         0x07    && English (South Africa) 
#DEFINE SUBLANG_ENGLISH_JAMAICA              0x08    && English (Jamaica) 
#DEFINE SUBLANG_ENGLISH_CARIBBEAN            0x09    && English (Caribbean) 
#DEFINE SUBLANG_ENGLISH_BELIZE               0x0a    && English (Belize) 
#DEFINE SUBLANG_ENGLISH_TRINIDAD             0x0b    && English (Trinidad) 
#DEFINE SUBLANG_FRENCH                       0x01    && French 
#DEFINE SUBLANG_FRENCH_BELGIAN               0x02    && French (Belgian) 
#DEFINE SUBLANG_FRENCH_CANADIAN              0x03    && French (Canadian) 
#DEFINE SUBLANG_FRENCH_SWISS                 0x04    && French (Swiss) 
#DEFINE SUBLANG_FRENCH_LUXEMBOURG            0x05    && French (Luxembourg) 
#DEFINE SUBLANG_GERMAN                       0x01    && German 
#DEFINE SUBLANG_GERMAN_SWISS                 0x02    && German (Swiss) 
#DEFINE SUBLANG_GERMAN_AUSTRIAN              0x03    && German (Austrian) 
#DEFINE SUBLANG_GERMAN_LUXEMBOURG            0x04    && German (Luxembourg) 
#DEFINE SUBLANG_GERMAN_LIECHTENSTEIN         0x05    && German (Liechtenstein) 
#DEFINE SUBLANG_ITALIAN                      0x01    && Italian 
#DEFINE SUBLANG_ITALIAN_SWISS                0x02    && Italian (Swiss) 
#DEFINE SUBLANG_KOREAN                       0x01    && Korean (Extended Wansung) 
#DEFINE SUBLANG_KOREAN_JOHAB                 0x02    && Korean (Johab) 
#DEFINE SUBLANG_NORWEGIAN_BOKMAL             0x01    && Norwegian (Bokmal) 
#DEFINE SUBLANG_NORWEGIAN_NYNORSK            0x02    && Norwegian (Nynorsk) 
#DEFINE SUBLANG_PORTUGUESE                   0x02    && Portuguese 
#DEFINE SUBLANG_PORTUGUESE_BRAZILIAN         0x01    && Portuguese (Brazilian) 
#DEFINE SUBLANG_SERBIAN_LATIN                0x02    && Serbian (Latin) 
#DEFINE SUBLANG_SERBIAN_CYRILLIC             0x03    && Serbian (Cyrillic) 
#DEFINE SUBLANG_SPANISH                      0x01    && Spanish (Castilian) 
#DEFINE SUBLANG_SPANISH_MEXICAN              0x02    && Spanish (Mexican) 
#DEFINE SUBLANG_SPANISH_MODERN               0x03    && Spanish (Modern) 
#DEFINE SUBLANG_SPANISH_GUATEMALA            0x04    && Spanish (Guatemala) 
#DEFINE SUBLANG_SPANISH_COSTA_RICA           0x05    && Spanish (Costa Rica) 
#DEFINE SUBLANG_SPANISH_PANAMA               0x06    && Spanish (Panama) 
#DEFINE SUBLANG_SPANISH_DOMINICAN_REPUBLIC   0x07    && Spanish (Dominican Republic) 
#DEFINE SUBLANG_SPANISH_VENEZUELA            0x08    && Spanish (Venezuela) 
#DEFINE SUBLANG_SPANISH_COLOMBIA             0x09    && Spanish (Colombia) 
#DEFINE SUBLANG_SPANISH_PERU                 0x0a    && Spanish (Peru) 
#DEFINE SUBLANG_SPANISH_ARGENTINA            0x0b    && Spanish (Argentina) 
#DEFINE SUBLANG_SPANISH_ECUADOR              0x0c    && Spanish (Ecuador) 
#DEFINE SUBLANG_SPANISH_CHILE                0x0d    && Spanish (Chile) 
#DEFINE SUBLANG_SPANISH_URUGUAY              0x0e    && Spanish (Uruguay) 
#DEFINE SUBLANG_SPANISH_PARAGUAY             0x0f    && Spanish (Paraguay) 
#DEFINE SUBLANG_SPANISH_BOLIVIA              0x10    && Spanish (Bolivia) 
#DEFINE SUBLANG_SPANISH_EL_SALVADOR          0x11    && Spanish (El Salvador) 
#DEFINE SUBLANG_SPANISH_HONDURAS             0x12    && Spanish (Honduras) 
#DEFINE SUBLANG_SPANISH_NICARAGUA            0x13    && Spanish (Nicaragua) 
#DEFINE SUBLANG_SPANISH_PUERTO_RICO          0x14    && Spanish (Puerto Rico) 
#DEFINE SUBLANG_SWEDISH                      0x01    && Swedish 
#DEFINE SUBLANG_SWEDISH_FINLAND              0x02    && Swedish (Finland) 
